<?php
/*
 * NwCreateBlockByStatus 
 *
 * Copyright(c) 2009-2012 NAKWEB CO.,LTD. All Rights Reserved.
 *
 * http://ec-cube.nakweb.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/**
 * NwCreateBlockByStatus のページクラス.
 *
 * @package NwCreateBlockByStatus
 * @author NAKWEB CO.,LTD.
 */
class NwCreateBlockByStatus extends SC_Plugin_Base {

    /**
     * コンストラクタ
     *
     */
    public function __construct(array $arrSelfInfo) {
        parent::__construct($arrSelfInfo);
    }

    /**
     * インストール
     * installはプラグインのインストール時に実行されます.
     * 引数にはdtb_pluginのプラグイン情報が渡されます.
     *
     * @param array $arrPlugin plugin_infoを元にDBに登録されたプラグイン情報(dtb_plugin)
     * @return void
     */
    function install($arrPlugin) {
        $objQuery = SC_Query_Ex::getSingletonInstance();

        // 画像ファイルは、html/plugin 以下にコピー
        if(copy(PLUGIN_UPLOAD_REALDIR . "NwCreateBlockByStatus/logo.png", PLUGIN_HTML_REALDIR . "NwCreateBlockByStatus/logo.png") === false) print_r("失敗");

		// PHPファイルは、html 以下にコピー
		if(copy(PLUGIN_UPLOAD_REALDIR . "NwCreateBlockByStatus/bloc/status_products.php", HTML_REALDIR . "frontparts/bloc/status_products.php") === false) print_r("失敗");

		// TPLファイルは、data/Smarty/templates/default 以下にコピー
		if(copy(PLUGIN_UPLOAD_REALDIR . "NwCreateBlockByStatus/templates/status_products.tpl", TEMPLATE_REALDIR . "frontparts/bloc/status_products.tpl") === false) print_r("失敗");

		// CSSファイルは、html/plugin 以下にコピー
    	if(copy(PLUGIN_UPLOAD_REALDIR . "NwCreateBlockByStatus/status_products.css", PLUGIN_HTML_REALDIR . "NwCreateBlockByStatus/status_products.css") === false) print_r("失敗");
    }

    /**
     * アンインストール
     * uninstallはアンインストール時に実行されます.
     * 引数にはdtb_pluginのプラグイン情報が渡されます.
     *
     * @param array $arrPlugin プラグイン情報の連想配列(dtb_plugin)
     * @return void
     */
    function uninstall($arrPlugin) {
        $objQuery = SC_Query_Ex::getSingletonInstance();

		if(SC_Helper_FileManager_Ex::deleteFile(PLUGIN_HTML_REALDIR . "NwCreateBlockByStatus/logo.png") === false) print_r("失敗");
		if(SC_Helper_FileManager_Ex::deleteFile(HTML_REALDIR . "frontparts/bloc/status_products.php") === false) print_r("失敗");
		if(SC_Helper_FileManager_Ex::deleteFile(TEMPLATE_REALDIR . "frontparts/bloc/status_products.tpl") === false) print_r("失敗");
		if(SC_Helper_FileManager_Ex::deleteFile(PLUGIN_HTML_REALDIR . "NwCreateBlockByStatus/status_products.css") === false) print_r("失敗");
		if(SC_Helper_FileManager_Ex::deleteFile(PLUGIN_HTML_REALDIR . "NwCreateBlockByStatus") === false) print_r("失敗");
    }

    /**
     * アップデート
     * updateはアップデート時に実行されます.
     * 引数にはdtb_pluginのプラグイン情報が渡されます.
     *
     * @param array $arrPlugin プラグイン情報の連想配列(dtb_plugin)
     * @return void
     */
    function update($arrPlugin) {
        // nop
    }

    /**
     * 稼働
     * enableはプラグインを有効にした際に実行されます.
     * 引数にはdtb_pluginのプラグイン情報が渡されます.
     *
     * @param array $arrPlugin プラグイン情報の連想配列(dtb_plugin)
     * @return void
     */
    function enable($arrPlugin) {
        //プラグイン専用テーブルの作成
        $objQuery =& SC_Query_Ex::getSingletonInstance();
        $objQuery->begin();

        //dtb_blocにブロックを追加する.
        $sqlval_bloc = array();
        $sqlval_bloc['device_type_id'] = DEVICE_TYPE_PC;
        $sqlval_bloc['bloc_id'] = $objQuery->max('bloc_id', "dtb_bloc", "device_type_id = " . DEVICE_TYPE_PC) + 1;
        $sqlval_bloc['bloc_name'] = $arrPlugin['plugin_name'];
        $sqlval_bloc['tpl_path'] = "status_products.tpl";
        $sqlval_bloc['filename'] = "status_products";
        $sqlval_bloc['create_date'] = "CURRENT_TIMESTAMP";
        $sqlval_bloc['update_date'] = "CURRENT_TIMESTAMP";
        $sqlval_bloc['php_path'] = "frontparts/bloc/status_products.php";
        $sqlval_bloc['deletable_flg'] = 0;
        $sqlval_bloc['plugin_id'] = $arrPlugin['plugin_id'];
        $objQuery->insert("dtb_bloc", $sqlval_bloc);

		//mtb_constantsに追加
		$sqlval_con = array();
		$sqlval_con['id'] = 'PLG_NWCREATEBLOCKBYSTATUS_STATUS_ID';
        $sqlval_con['name'] = 1;
        $sqlval_con['rank'] = $objQuery->max('rank', "mtb_constants") + 1;
        $sqlval_con['remarks'] = 'ステータス商品表示プラグインで、商品一覧表示に使用するステータスID';
		$objQuery->insert("mtb_constants", $sqlval_con);

        $sqlval_con = array();
        $sqlval_con['id'] = 'PLG_NWCREATEBLOCKBYSTATUS_TITLE';
        $sqlval_con['name'] = '新着商品';
        $sqlval_con['rank'] = $objQuery->max('rank', "mtb_constants") + 1;
        $sqlval_con['remarks'] = 'ステータス商品表示プラグインで、表示ブロックのタイトル';
        $objQuery->insert("mtb_constants", $sqlval_con);

        $sqlval_con = array();
        $sqlval_con['id'] = 'PLG_NWCREATEBLOCKBYSTATUS_COUNT';
        $sqlval_con['name'] = 4;
        $sqlval_con['rank'] = $objQuery->max('rank', "mtb_constants") + 1;
        $sqlval_con['remarks'] = 'ステータス商品表示プラグインで、商品表示する個数';
        $objQuery->insert("mtb_constants", $sqlval_con);

        $objQuery->commit();
    }

    /**
     * 停止
     * disableはプラグインを無効にした際に実行されます.
     * 引数にはdtb_pluginのプラグイン情報が渡されます.
     *
     * @param array $arrPlugin プラグイン情報の連想配列(dtb_plugin)
     * @return void
     */
    function disable($arrPlugin) {
        $objQuery = SC_Query_Ex::getSingletonInstance();
        $arrBlocId = $objQuery->getCol('bloc_id', "dtb_bloc", "device_type_id = ? AND plugin_id = ?", array(DEVICE_TYPE_PC , $arrPlugin['plugin_id']));
        $bloc_id = (int) $arrBlocId[0];

        //ブロック削除
        $where = "device_type_id = 10 AND bloc_id = ?";
        $objQuery->delete("dtb_bloc", $where, array($bloc_id));

		//ブロックレイアウト削除
        $where = "device_type_id = 10 AND bloc_id = ?";
        $objQuery->delete("dtb_blocposition", $where, array($bloc_id));

		//mtb_constants削除
		$where = "id = ?";
		$arrval = array("PLG_NWCREATEBLOCKBYSTATUS_STATUS_ID");
		$objQuery->delete("mtb_constants", $where, $arrval);

        $where = "id = ?";
        $arrval = array("PLG_NWCREATEBLOCKBYSTATUS_TITLE");
        $objQuery->delete("mtb_constants", $where, $arrval);

        $where = "id = ?";
        $arrval = array("PLG_NWCREATEBLOCKBYSTATUS_COUNT");
        $objQuery->delete("mtb_constants", $where, $arrval);
    }

    /**
     * 処理の介入箇所とコールバック関数を設定
     * registerはプラグインインスタンス生成時に実行されます
     *
     * @param SC_Helper_Plugin $objHelperPlugin
     */
    function register(SC_Helper_Plugin $objHelperPlugin) {
        $template_dir = PLUGIN_UPLOAD_REALDIR . 'NwCreateBlockByStatus/templates/';
        $objHelperPlugin->setHeadNavi($template_dir . 'header.tpl');
    }

}
?>
